/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.NewEntry;
import org.openapitools.client.model.SearchEntry;
import org.openapitools.client.model.SearchResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SearchApi {
    private ApiClient localVarApiClient;

    public SearchApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SearchApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for searchDuplicatesPost
     * @param newEntry  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call searchDuplicatesPostCall(NewEntry newEntry, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = newEntry;

        // create path and map variables
        String localVarPath = "/search/duplicates";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call searchDuplicatesPostValidateBeforeCall(NewEntry newEntry, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'newEntry' is set
        if (newEntry == null) {
            throw new ApiException("Missing the required parameter 'newEntry' when calling searchDuplicatesPost(Async)");
        }
        

        okhttp3.Call localVarCall = searchDuplicatesPostCall(newEntry, _callback);
        return localVarCall;

    }

    /**
     * Search for duplicate places
     * Search for similiar places that might be duplicates of a given place.  Currently only the geographical location and title and are considered to find similar, already existing entries in the database.  Returns a list of possible duplicates for the given place. 
     * @param newEntry  (required)
     * @return List&lt;SearchEntry&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public List<SearchEntry> searchDuplicatesPost(NewEntry newEntry) throws ApiException {
        ApiResponse<List<SearchEntry>> localVarResp = searchDuplicatesPostWithHttpInfo(newEntry);
        return localVarResp.getData();
    }

    /**
     * Search for duplicate places
     * Search for similiar places that might be duplicates of a given place.  Currently only the geographical location and title and are considered to find similar, already existing entries in the database.  Returns a list of possible duplicates for the given place. 
     * @param newEntry  (required)
     * @return ApiResponse&lt;List&lt;SearchEntry&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<SearchEntry>> searchDuplicatesPostWithHttpInfo(NewEntry newEntry) throws ApiException {
        okhttp3.Call localVarCall = searchDuplicatesPostValidateBeforeCall(newEntry, null);
        Type localVarReturnType = new TypeToken<List<SearchEntry>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Search for duplicate places (asynchronously)
     * Search for similiar places that might be duplicates of a given place.  Currently only the geographical location and title and are considered to find similar, already existing entries in the database.  Returns a list of possible duplicates for the given place. 
     * @param newEntry  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call searchDuplicatesPostAsync(NewEntry newEntry, final ApiCallback<List<SearchEntry>> _callback) throws ApiException {

        okhttp3.Call localVarCall = searchDuplicatesPostValidateBeforeCall(newEntry, _callback);
        Type localVarReturnType = new TypeToken<List<SearchEntry>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for searchGet
     * @param bbox Bounding Box (optional)
     * @param orgTag A single hash tag that is moderated by an organization.  Results will be filtered according to the current clearance status. Unclear revisions of entries will either be removed or replaced by older, already cleared revisions. Unclear revisions of entries are expected to only exist temporarily for a short time frame until a newer version has been cleared.  If the provided hash tag is not moderated by any organization the results will not be filtered by clearance status.  Only a single tag can be specified, because filtering according to clearance by multiple organizations could produce ambiguous and conflicting results.  Only when used in search requests: The hash tag will be included in the query as a mandatory search criteria like any other tag. Omitting this parameter and instead appending the moderated hash tag as a regular tag to the &#x60;tags&#x60; parameter will also return unfiltered search results, i.e. current revisions of entries independent of their clearance status.  (optional)
     * @param categories Comma-separated list of category identifiers. We currently use the following two: - Initiative (non-commercial): &#x60;2cd00bebec0c48ba9db761da48678134&#x60; - Company (commercial): &#x60;77b3c33a92554bcf8e8c2c86cedd6f6f&#x60;  (optional)
     * @param text  (optional)
     * @param ids  (optional)
     * @param tags  (optional)
     * @param status  (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call searchGetCall(String bbox, String orgTag, String categories, String text, String ids, String tags, String status, Long limit, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/search";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (bbox != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("bbox", bbox));
        }

        if (orgTag != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("org_tag", orgTag));
        }

        if (categories != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("categories", categories));
        }

        if (text != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("text", text));
        }

        if (ids != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("ids", ids));
        }

        if (tags != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("tags", tags));
        }

        if (status != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("status", status));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call searchGetValidateBeforeCall(String bbox, String orgTag, String categories, String text, String ids, String tags, String status, Long limit, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = searchGetCall(bbox, orgTag, categories, text, ids, tags, status, limit, _callback);
        return localVarCall;

    }

    /**
     * Search for places
     * Query the database for entries/places according to the search criteria and order the top matching results by their total rating in descending oder.  The default result contains up to 100 entries. Use the &#x60;limit&#x60; parameter to customize the desired amount. The server may decide to deliver less results than requested up to some internal upper limit (currently 500).  If the review status list is empty or missing only visible places (created, confirmed) are returned. 
     * @param bbox Bounding Box (optional)
     * @param orgTag A single hash tag that is moderated by an organization.  Results will be filtered according to the current clearance status. Unclear revisions of entries will either be removed or replaced by older, already cleared revisions. Unclear revisions of entries are expected to only exist temporarily for a short time frame until a newer version has been cleared.  If the provided hash tag is not moderated by any organization the results will not be filtered by clearance status.  Only a single tag can be specified, because filtering according to clearance by multiple organizations could produce ambiguous and conflicting results.  Only when used in search requests: The hash tag will be included in the query as a mandatory search criteria like any other tag. Omitting this parameter and instead appending the moderated hash tag as a regular tag to the &#x60;tags&#x60; parameter will also return unfiltered search results, i.e. current revisions of entries independent of their clearance status.  (optional)
     * @param categories Comma-separated list of category identifiers. We currently use the following two: - Initiative (non-commercial): &#x60;2cd00bebec0c48ba9db761da48678134&#x60; - Company (commercial): &#x60;77b3c33a92554bcf8e8c2c86cedd6f6f&#x60;  (optional)
     * @param text  (optional)
     * @param ids  (optional)
     * @param tags  (optional)
     * @param status  (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @return SearchResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public SearchResponse searchGet(String bbox, String orgTag, String categories, String text, String ids, String tags, String status, Long limit) throws ApiException {
        ApiResponse<SearchResponse> localVarResp = searchGetWithHttpInfo(bbox, orgTag, categories, text, ids, tags, status, limit);
        return localVarResp.getData();
    }

    /**
     * Search for places
     * Query the database for entries/places according to the search criteria and order the top matching results by their total rating in descending oder.  The default result contains up to 100 entries. Use the &#x60;limit&#x60; parameter to customize the desired amount. The server may decide to deliver less results than requested up to some internal upper limit (currently 500).  If the review status list is empty or missing only visible places (created, confirmed) are returned. 
     * @param bbox Bounding Box (optional)
     * @param orgTag A single hash tag that is moderated by an organization.  Results will be filtered according to the current clearance status. Unclear revisions of entries will either be removed or replaced by older, already cleared revisions. Unclear revisions of entries are expected to only exist temporarily for a short time frame until a newer version has been cleared.  If the provided hash tag is not moderated by any organization the results will not be filtered by clearance status.  Only a single tag can be specified, because filtering according to clearance by multiple organizations could produce ambiguous and conflicting results.  Only when used in search requests: The hash tag will be included in the query as a mandatory search criteria like any other tag. Omitting this parameter and instead appending the moderated hash tag as a regular tag to the &#x60;tags&#x60; parameter will also return unfiltered search results, i.e. current revisions of entries independent of their clearance status.  (optional)
     * @param categories Comma-separated list of category identifiers. We currently use the following two: - Initiative (non-commercial): &#x60;2cd00bebec0c48ba9db761da48678134&#x60; - Company (commercial): &#x60;77b3c33a92554bcf8e8c2c86cedd6f6f&#x60;  (optional)
     * @param text  (optional)
     * @param ids  (optional)
     * @param tags  (optional)
     * @param status  (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @return ApiResponse&lt;SearchResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<SearchResponse> searchGetWithHttpInfo(String bbox, String orgTag, String categories, String text, String ids, String tags, String status, Long limit) throws ApiException {
        okhttp3.Call localVarCall = searchGetValidateBeforeCall(bbox, orgTag, categories, text, ids, tags, status, limit, null);
        Type localVarReturnType = new TypeToken<SearchResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Search for places (asynchronously)
     * Query the database for entries/places according to the search criteria and order the top matching results by their total rating in descending oder.  The default result contains up to 100 entries. Use the &#x60;limit&#x60; parameter to customize the desired amount. The server may decide to deliver less results than requested up to some internal upper limit (currently 500).  If the review status list is empty or missing only visible places (created, confirmed) are returned. 
     * @param bbox Bounding Box (optional)
     * @param orgTag A single hash tag that is moderated by an organization.  Results will be filtered according to the current clearance status. Unclear revisions of entries will either be removed or replaced by older, already cleared revisions. Unclear revisions of entries are expected to only exist temporarily for a short time frame until a newer version has been cleared.  If the provided hash tag is not moderated by any organization the results will not be filtered by clearance status.  Only a single tag can be specified, because filtering according to clearance by multiple organizations could produce ambiguous and conflicting results.  Only when used in search requests: The hash tag will be included in the query as a mandatory search criteria like any other tag. Omitting this parameter and instead appending the moderated hash tag as a regular tag to the &#x60;tags&#x60; parameter will also return unfiltered search results, i.e. current revisions of entries independent of their clearance status.  (optional)
     * @param categories Comma-separated list of category identifiers. We currently use the following two: - Initiative (non-commercial): &#x60;2cd00bebec0c48ba9db761da48678134&#x60; - Company (commercial): &#x60;77b3c33a92554bcf8e8c2c86cedd6f6f&#x60;  (optional)
     * @param text  (optional)
     * @param ids  (optional)
     * @param tags  (optional)
     * @param status  (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call searchGetAsync(String bbox, String orgTag, String categories, String text, String ids, String tags, String status, Long limit, final ApiCallback<SearchResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = searchGetValidateBeforeCall(bbox, orgTag, categories, text, ids, tags, status, limit, _callback);
        Type localVarReturnType = new TypeToken<SearchResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
